/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   GetType.cpp                                        :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: adjoly <adjoly@student.42angouleme.fr>     +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2025/04/09 09:05:44 by adjoly            #+#    #+#             */
/*   Updated: 2025/04/09 09:18:37 by adjoly           ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "GetType.hpp"
#include <cctype>
#include <cstdlib>

bool _isNan(const std::string &str) {
	if (str == "nan" || str == "nanf" || str == "-inf" || str == "-inff" ||
		str == "+inf" || str == "+inff" || str == "inf" || str == "inff")
		return true;
	return false;
}

nbType GetType(const std::string &str) { 
	if (_isNan(str))
		return NAN;
	if (str.length() == 1 && !isdigit(str[0]))
		return CHAR;

	char *err;

	(void)strtol(str.c_str(), &err, 10);
	if (*err == 0)
		return INT;
	(void)strtod(str.c_str(), &err);
	if (*err == 0)
		return DOUBLE;
	if (*err == 'f' && *(err + 1) == 0)
		return FLOAT;
	return NONE;
}
